/*
	RT Bench - Benchmarks various hash functions for Rainbow Tables
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef HASH_CISCO_H
#define HASH_CISCO_H

#include "common.h"

class Cisco
{
public:
#ifdef ARC_x86
	static void calcAVXXOP (vector4 *pw, vector4 *hash);
	static void calcAVX    (vector4 *pw, vector4 *hash);
	static void calcSSE2   (vector4 *pw, vector4 *hash);
#endif
	static void calcNorm   (vector4 *pw, vector4 *hash);

private:
	Cisco() {}
	static uint32_t initCalc();
	static uint32_t inited;
};

#endif
